; port7--The Link Port Driver v1.0
; Copyright (C) 1997 by Keith Burzinski <tsk3000@Prodigy.Net>
; -----
#include "TI-85.H"

.org 0
.db "Link Port Driver v1.0",0

Init:
    ROM_CALL(CLEARLCD)
    ld  hl,$0000
    ld  ($800C),hl
    ld  hl,OutStr
    ld  de,(PROGRAM_ADDR)
    add hl,de
    ROM_CALL(D_ZT_STR)
    ld  hl,$0001
    ld  ($800C),hl
    ld  hl,InStr
    ld  de,(PROGRAM_ADDR)
    add hl,de
    ROM_CALL(D_ZT_STR)
    ld  hl,$3A01
    ld  (CURSOR_X),hl
    ld  hl,AuthorStr
    ld  de,(PROGRAM_ADDR)
    add hl,de
    ROM_CALL(D_ZM_STR)

KeyLoop:
    CALL_(UpdateInput)

    call get_key

    cp  K_0
    jr  z,SetBoth

    cp  K_1
    jr  z,SetWonly

    cp  K_2
    jr  z,SetRonly

    cp  K_3
    jr  z,ClearBoth
    
    cp  K_EXIT
    jr  z,Exit

    jr  KeyLoop

SetBoth:
    ld  a,$C0                             ; R+ W+
    out (7),a
    ld  hl,$0900
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    jr  Put1W

SetWonly:
    ld  a, $D4                            ; R- W+
    out (7),a
    ld  hl,$0900
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
Put1W:
    ld  hl,$0F00
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    jr  KeyLoop

SetRonly:
    ld  a,$E8                            ; R+ W-
    out (7),a
    ld  hl,$0900
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    jr  Put0W

ClearBoth:
    ld  a, $FC                            ; R- W-
    out (7),a
    ld  hl,$0900
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
Put0W:
    ld  hl,$0F00
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
    jr  KeyLoop

Exit:
    ld  a,$C0                              ; R+ W+
    out (7),a
    ret

UpdateInput:
    in  a,(7)
    and 3

    cp  0
    jr  z,BothClear

    cp  1
    jr  z,RedClear

    cp  2
    jr  z,WhiteClear

BothSet:
    ld  hl,$0901
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    ld  hl,$0F01
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    ret

BothClear:
    ld  hl,$0901
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
    ld  hl,$0F01
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
    ret

WhiteClear:
    ld  hl,$0901
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
    ld  hl,$0F01
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    ret

RedClear:
    ld  hl,$0901
    ld  ($800C),hl
    ld  a,'1'
    ROM_CALL(TX_CHARPUT)
    ld  hl,$0F01
    ld  ($800C),hl
    ld  a,'0'
    ROM_CALL(TX_CHARPUT)
    ret

OutStr:
    .db "Outpt: R=1   W=1",0

InStr:
    .db "Input: R=1   W=1",0

AuthorStr:
    .db "By K. Burzinski   "
    .db "TSK3000@Prodigy.Net",0

.end
